diff --git a/Platform/Hisilicon/D02/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf b/Platform/Hisilicon/D02/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
index 8376bbd..8b9ee1d 100644
--- a/Platform/Hisilicon/D02/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
+++ b/Platform/Hisilicon/D02/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = SnpPV600Dxe
-  FILE_GUID                      = 3246F154-3612-4803-BD4E-4104D7EF944A
+  FILE_GUID                      = 1AB373EB-2CD7-4D5C-9C39-D31845B67F5E
   MODULE_TYPE                    = UEFI_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D02/Drivers/SFC/SfcDxeDriver.inf b/Platform/Hisilicon/D02/Drivers/SFC/SfcDxeDriver.inf
index e10275a..02a4d7f 100644
--- a/Platform/Hisilicon/D02/Drivers/SFC/SfcDxeDriver.inf
+++ b/Platform/Hisilicon/D02/Drivers/SFC/SfcDxeDriver.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = SFCDriver
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = 02C6BAAE-6E43-4910-8084-60D5045729A0
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = SFCInitialize
diff --git a/Platform/Hisilicon/D02/MemoryInitPei/MemoryInitPeim.inf b/Platform/Hisilicon/D02/MemoryInitPei/MemoryInitPeim.inf
index c221de9..0095c82 100644
--- a/Platform/Hisilicon/D02/MemoryInitPei/MemoryInitPeim.inf
+++ b/Platform/Hisilicon/D02/MemoryInitPei/MemoryInitPeim.inf
@@ -18,7 +18,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = MemoryInit
-  FILE_GUID                      = c61ef796-b50d-4f98-9f78-4f6f79d800d5
+  FILE_GUID                      = A311058D-0993-4C05-A3EC-16CC0801C1A0
   MODULE_TYPE                    = PEIM
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/GetInfoFromBmc/GetInfoFromBmc.inf b/Platform/Hisilicon/D05/Drivers/GetInfoFromBmc/GetInfoFromBmc.inf
index 20e2f05..1a2bd01 100644
--- a/Platform/Hisilicon/D05/Drivers/GetInfoFromBmc/GetInfoFromBmc.inf
+++ b/Platform/Hisilicon/D05/Drivers/GetInfoFromBmc/GetInfoFromBmc.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = GetInfoFromBmc
-  FILE_GUID                      = 43B59C81-9C5F-4021-B0F2-947DB839B781
+  FILE_GUID                      = DFDF885A-623D-4D13-9EB6-8454BA30A7CD
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = GetBmcInfoDriverEntry
diff --git a/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfaceDxe/IpmiInterfaceDxe.inf b/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfaceDxe/IpmiInterfaceDxe.inf
index a614b68..e82e5ad 100644
--- a/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfaceDxe/IpmiInterfaceDxe.inf
+++ b/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfaceDxe/IpmiInterfaceDxe.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = IpmiInterfaceDxe
-  FILE_GUID                      = EF5483F8-68AD-4D71-9A23-674D2E9C013E
+  FILE_GUID                      = 89DCAC3C-D653-4FD7-82E7-9840ED7E0B1D
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfacePei/IpmiInterfacePei.inf b/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfacePei/IpmiInterfacePei.inf
index e55d3f7..ac9f467 100644
--- a/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfacePei/IpmiInterfacePei.inf
+++ b/Platform/Hisilicon/D05/Drivers/Ipmi/IpmiInterfacePei/IpmiInterfacePei.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = IpmiInterfacePei
-  FILE_GUID                      = 269702AF-8004-4570-A08E-00762AE65D15
+  FILE_GUID                      = 0E169987-AC8F-4DF8-9A67-D2860C15699D
   MODULE_TYPE                    = PEIM
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = IpmiInterfacePeiEntry
diff --git a/Platform/Hisilicon/D05/Drivers/IpmiMiscOpDxe/IpmiMiscOpDxe.inf b/Platform/Hisilicon/D05/Drivers/IpmiMiscOpDxe/IpmiMiscOpDxe.inf
index 8075f40..8b94903 100644
--- a/Platform/Hisilicon/D05/Drivers/IpmiMiscOpDxe/IpmiMiscOpDxe.inf
+++ b/Platform/Hisilicon/D05/Drivers/IpmiMiscOpDxe/IpmiMiscOpDxe.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = IpmiMiscOp
-  FILE_GUID                      = EC68451C-6D10-4ba2-9862-D27D4D6090DB
+  FILE_GUID                      = 536C9EE4-3D34-4EB6-9195-7BEEDE4D4F9F
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = IpmiMiscOpEntry
diff --git a/Platform/Hisilicon/D05/Drivers/IpmiWatchdogDxe/IpmiWatchdogDxe.inf b/Platform/Hisilicon/D05/Drivers/IpmiWatchdogDxe/IpmiWatchdogDxe.inf
index c173587..510c59d 100644
--- a/Platform/Hisilicon/D05/Drivers/IpmiWatchdogDxe/IpmiWatchdogDxe.inf
+++ b/Platform/Hisilicon/D05/Drivers/IpmiWatchdogDxe/IpmiWatchdogDxe.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = IpmiWatchdogDxe
-  FILE_GUID                      = 7C7ACA9F-DB25-43FB-A479-1B6E42F38792
+  FILE_GUID                      = 4C112583-9092-4712-BBBF-429B4B66220F
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = InitializeWatchdogDxeEntry
diff --git a/Platform/Hisilicon/D05/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf b/Platform/Hisilicon/D05/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
index 90e478d..cb7ef81 100644
--- a/Platform/Hisilicon/D05/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
+++ b/Platform/Hisilicon/D05/Drivers/Net/SnpPV600Dxe/SnpPV600Dxe.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = SnpPV600Dxe
-  FILE_GUID                      = 3247F15F-3612-4803-BD4E-4104D7EF944A
+  FILE_GUID                      = 6BB8E531-2E49-43CC-AF7A-7CABDAEB7B7A
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/OhciDxe/OhciDxe.inf b/Platform/Hisilicon/D05/Drivers/OhciDxe/OhciDxe.inf
index 80d9c49..d0a8d7b 100644
--- a/Platform/Hisilicon/D05/Drivers/OhciDxe/OhciDxe.inf
+++ b/Platform/Hisilicon/D05/Drivers/OhciDxe/OhciDxe.inf
@@ -17,7 +17,7 @@
 [defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = NativeOhci
-  FILE_GUID                      = 043D0B5E-DAC1-463a-85BA-2CEDC33A8C4F
+  FILE_GUID                      = 559F7D9C-34A8-4028-815C-D5A73EDEB60F
   MODULE_TYPE                    = UEFI_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/ReportPciePlugDidVidToBmc/ReportPciePlugDidVidToBmc.inf b/Platform/Hisilicon/D05/Drivers/ReportPciePlugDidVidToBmc/ReportPciePlugDidVidToBmc.inf
index ab2be5e..bcc05cb 100644
--- a/Platform/Hisilicon/D05/Drivers/ReportPciePlugDidVidToBmc/ReportPciePlugDidVidToBmc.inf
+++ b/Platform/Hisilicon/D05/Drivers/ReportPciePlugDidVidToBmc/ReportPciePlugDidVidToBmc.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = ReportPciePlugDidVidToBmc
-  FILE_GUID                      = 9BC4A5D1-5A46-4A6C-AF11-4875268179D3
+  FILE_GUID                      = 5C6B2DC9-D4F5-405A-94A4-4EA9E74A1800
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/SFC/SfcDxeDriver.inf b/Platform/Hisilicon/D05/Drivers/SFC/SfcDxeDriver.inf
index 909462f..e14723c 100644
--- a/Platform/Hisilicon/D05/Drivers/SFC/SfcDxeDriver.inf
+++ b/Platform/Hisilicon/D05/Drivers/SFC/SfcDxeDriver.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = SFCDriver
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = 209D1FBE-506F-40BB-9C67-4B6085F92010
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = SFCInitialize
diff --git a/Platform/Hisilicon/D05/Drivers/Sas/SasDxeDriver.inf b/Platform/Hisilicon/D05/Drivers/Sas/SasDxeDriver.inf
index 539d612..3daf2bb 100644
--- a/Platform/Hisilicon/D05/Drivers/Sas/SasDxeDriver.inf
+++ b/Platform/Hisilicon/D05/Drivers/Sas/SasDxeDriver.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = SasDriverDxe
-  FILE_GUID                      = 49ea041e-6752-42ca-b0b1-7344fe234567
+  FILE_GUID                      = 6F39A263-C676-4FED-8609-33148079C721
   MODULE_TYPE                    = UEFI_DRIVER
   VERSION_STRING                 = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/Sm750Dxe/UefiSmi.inf b/Platform/Hisilicon/D05/Drivers/Sm750Dxe/UefiSmi.inf
index 0590919..5927561 100644
--- a/Platform/Hisilicon/D05/Drivers/Sm750Dxe/UefiSmi.inf
+++ b/Platform/Hisilicon/D05/Drivers/Sm750Dxe/UefiSmi.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION          = 0x00010019
   BASE_NAME            = SmiGraphicsOutput
-  FILE_GUID            = BFB7B510-B09B-11DB-96E3-005056C00008
+  FILE_GUID            = 12584EAB-60CB-43B0-8806-1AE5BEDEEF02
   MODULE_TYPE          = UEFI_DRIVER
   VERSION_STRING       = 1.0
 
diff --git a/Platform/Hisilicon/D05/Drivers/TransferSmbiosInfo/TransSmbiosInfo.inf b/Platform/Hisilicon/D05/Drivers/TransferSmbiosInfo/TransSmbiosInfo.inf
index 6b34037..01afa26 100644
--- a/Platform/Hisilicon/D05/Drivers/TransferSmbiosInfo/TransSmbiosInfo.inf
+++ b/Platform/Hisilicon/D05/Drivers/TransferSmbiosInfo/TransSmbiosInfo.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = TransSmbiosInfo
-  FILE_GUID                      = 13668C32-1977-436a-800C-F8644D11CB76
+  FILE_GUID                      = 7FCDA10D-F216-4BAD-9D5C-FBF782A305FD
   MODULE_TYPE                    = DXE_DRIVER
   VERSION_STRING                 = 1.0
   ENTRY_POINT                    = TransferSmbiosInfoToBMC
diff --git a/Platform/Hisilicon/D05/Library/OemAddressMapD05/OemAddressMapD05.inf b/Platform/Hisilicon/D05/Library/OemAddressMapD05/OemAddressMapD05.inf
index 79e0d8e..ecf61b8 100644
--- a/Platform/Hisilicon/D05/Library/OemAddressMapD05/OemAddressMapD05.inf
+++ b/Platform/Hisilicon/D05/Library/OemAddressMapD05/OemAddressMapD05.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = OemAddressMapD05
-  FILE_GUID                      = 32BC48E3-5428-4556-A383-25A23EA816A7
+  FILE_GUID                      = 8F35288F-9AD2-4B4A-ABC2-D97654FB3E5C
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = OemAddressMapLib
diff --git a/Platform/Hisilicon/D05/MemoryInitPei/MemoryInitPeim.inf b/Platform/Hisilicon/D05/MemoryInitPei/MemoryInitPeim.inf
index da28c5a..b863dc2 100644
--- a/Platform/Hisilicon/D05/MemoryInitPei/MemoryInitPeim.inf
+++ b/Platform/Hisilicon/D05/MemoryInitPei/MemoryInitPeim.inf
@@ -18,7 +18,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = MemoryInit
-  FILE_GUID                      = c61ef796-b50d-4f98-9f78-4f6f79d800d5
+  FILE_GUID                      = 1E71DFDB-EB4F-465C-BBB3-93D3FEA48437
   MODULE_TYPE                    = PEIM
   VERSION_STRING                 = 1.0
 
diff --git a/Silicon/Hisilicon/Hi1610/Library/Hi1610Serdes/Hi1610SerdesLib.inf b/Silicon/Hisilicon/Hi1610/Library/Hi1610Serdes/Hi1610SerdesLib.inf
index a875f98..10ff0db 100644
--- a/Silicon/Hisilicon/Hi1610/Library/Hi1610Serdes/Hi1610SerdesLib.inf
+++ b/Silicon/Hisilicon/Hi1610/Library/Hi1610Serdes/Hi1610SerdesLib.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = Hi1610SerdesLib
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = BD95FDA9-54A4-4BDC-8EE6-47969ADF25F1
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = SerdesLib
diff --git a/Silicon/Hisilicon/Hi1610/Library/LpcLib/LpcLib.inf b/Silicon/Hisilicon/Hi1610/Library/LpcLib/LpcLib.inf
index dea2a72..308128f 100644
--- a/Silicon/Hisilicon/Hi1610/Library/LpcLib/LpcLib.inf
+++ b/Silicon/Hisilicon/Hi1610/Library/LpcLib/LpcLib.inf
@@ -17,7 +17,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = LpcLib
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = FEC691AE-110D-444E-9B85-0A8F2EFDCA65
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = LpcLib
diff --git a/Silicon/Hisilicon/Hi1610/Library/PlatformSysCtrlLibHi1610/PlatformSysCtrlLibHi1610.inf b/Silicon/Hisilicon/Hi1610/Library/PlatformSysCtrlLibHi1610/PlatformSysCtrlLibHi1610.inf
index 84125aa..fbf16d6 100644
--- a/Silicon/Hisilicon/Hi1610/Library/PlatformSysCtrlLibHi1610/PlatformSysCtrlLibHi1610.inf
+++ b/Silicon/Hisilicon/Hi1610/Library/PlatformSysCtrlLibHi1610/PlatformSysCtrlLibHi1610.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = PlatformSysCtrlLibHi1610
-  FILE_GUID                      = EBF63479-8F72-4ada-8B2A-960322F7F61A
+  FILE_GUID                      = 0DC0BBF4-2E09-4943-9534-48BF2EE274D3
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = PlatformSysCtrlLib
diff --git a/Silicon/Hisilicon/Hi1616/Library/Hi1616Serdes/Hi1616SerdesLib.inf b/Silicon/Hisilicon/Hi1616/Library/Hi1616Serdes/Hi1616SerdesLib.inf
index 49977ea..67d4a2b 100644
--- a/Silicon/Hisilicon/Hi1616/Library/Hi1616Serdes/Hi1616SerdesLib.inf
+++ b/Silicon/Hisilicon/Hi1616/Library/Hi1616Serdes/Hi1616SerdesLib.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010019
   BASE_NAME                      = Hi1616SerdesLib
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = 0CBCC289-639C-48E9-BEDD-039B21F5E97B
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = SerdesLib
diff --git a/Silicon/Hisilicon/Pv660/Library/PlatformSysCtrlLibPv660/PlatformSysCtrlLibPv660.inf b/Silicon/Hisilicon/Pv660/Library/PlatformSysCtrlLibPv660/PlatformSysCtrlLibPv660.inf
index 35d90df..e36c6b6 100644
--- a/Silicon/Hisilicon/Pv660/Library/PlatformSysCtrlLibPv660/PlatformSysCtrlLibPv660.inf
+++ b/Silicon/Hisilicon/Pv660/Library/PlatformSysCtrlLibPv660/PlatformSysCtrlLibPv660.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = PlatformSysCtrlLibPv660
-  FILE_GUID                      = EBF63479-8F72-4ada-8B2A-960322F7F61A
+  FILE_GUID                      = B6C2EF97-2E30-4AA4-A3F4-D4EB1BBA1CD2
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = PlatformSysCtrlLib
diff --git a/Silicon/Hisilicon/Pv660/Library/Pv660Serdes/Pv660SerdesLib.inf b/Silicon/Hisilicon/Pv660/Library/Pv660Serdes/Pv660SerdesLib.inf
index cd25daa..c9f3c0a 100644
--- a/Silicon/Hisilicon/Pv660/Library/Pv660Serdes/Pv660SerdesLib.inf
+++ b/Silicon/Hisilicon/Pv660/Library/Pv660Serdes/Pv660SerdesLib.inf
@@ -16,7 +16,7 @@
 [Defines]
   INF_VERSION                    = 0x00010005
   BASE_NAME                      = Pv660SerdesLib
-  FILE_GUID                      = FC5651CA-55D8-4fd2-B6D3-A284D993ABA2
+  FILE_GUID                      = 488347A3-8014-4DC4-8566-B51CA16CE0BB
   MODULE_TYPE                    = BASE
   VERSION_STRING                 = 1.0
   LIBRARY_CLASS                  = SerdesLib